=== libs/bloom/CMakeLists.txt ===
# Generated by `boostdep --cmake bloom`
# Copyright 2020, 2021 Peter Dimov
# Distributed under the Boost Software License, Version 1.0.
# https://www.boost.org/LICENSE_1_0.txt

cmake_minimum_required(VERSION 3.8...3.20)

project(boost_bloom VERSION "${BOOST_SUPERPROJECT_VERSION}" LANGUAGES CXX)

add_library(boost_bloom INTERFACE)
add_library(Boost::bloom ALIAS boost_bloom)

target_include_directories(boost_bloom INTERFACE include)

target_link_libraries(boost_bloom
  INTERFACE
    Boost::assert
    Boost::config
    Boost::container_hash
    Boost::core
    Boost::throw_exception
    Boost::type_traits
)

target_compile_features(boost_bloom INTERFACE cxx_std_11)

if(NOT CMAKE_VERSION VERSION_LESS 3.19 AND CMAKE_GENERATOR MATCHES "Visual Studio")

  file(GLOB_RECURSE boost_bloom_IDEFILES CONFIGURE_DEPENDS "include/*.hpp")
  source_group(TREE ${PROJECT_SOURCE_DIR}/include FILES ${boost_bloom_IDEFILES} PREFIX "Header Files")
  list(APPEND boost_bloom_IDEFILES extra/boost_bloom.natvis)
  target_sources(boost_bloom PRIVATE ${boost_bloom_IDEFILES})

endif()

if(BUILD_TESTING AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/test/CMakeLists.txt")

  add_subdirectory(test)

endif()
