=== debian/changelog ===
boost1.90 (1.90.0-5) unstable; urgency=medium

  * [6c5f56a] Better fix for reproducible build

 -- Anton Gladky <gladk@debian.org>  Fri, 20 Feb 2026 01:32:33 +0000

boost1.90 (1.90.0-4) unstable; urgency=medium

  [ John Paul Adrian Glaubitz ]
  * [aef8912] Add check for duplicate definition of SIGLOST. (Closes: #1128264)

  [ Anton Gladky ]
  * [55346d3] fix(debian): make build reproducible

 -- Anton Gladky <gladk@debian.org>  Wed, 18 Feb 2026 20:40:55 -0800

boost1.90 (1.90.0-3) unstable; urgency=medium

  [ Pino Toscano ]
  * [d6b6799] Disable boost.stacktrace.from_exception also on hurd-i386.

  [ Anton Gladky ]
  * [c1d2abd] skip mpi test on i386. (Closes: #1127608)

 -- Anton Gladky <gladk@debian.org>  Fri, 13 Feb 2026 22:50:16 +0000

boost1.90 (1.90.0-2) unstable; urgency=medium

  [ Matthias Klose ]
  * [c6e6e98] Update inter-package dependencies. (Closes: #1127143, #1127305)
  * [602001a] Update d/tests, remove signals tests. (Closes: #1127145)

  [ Anton Gladky ]
  * [6852a4a] chore(debian): Drop kfreebsd architectures support.
  * [253aab1] Disable several autopkgtests, all of them need to be reviewed,

  [ Simon Chopin ]
  * [c0c6afb] Dont clear CXXFLAGS when bootstrapping b2.

 -- Anton Gladky <gladk@debian.org>  Sat, 07 Feb 2026 19:43:58 +0100

boost1.90 (1.90.0-1) unstable; urgency=medium

  * Upload into unstable
  * [25bd8ef] Fix architecture restrictions in d/tests/control.
              (Closes: #1127057)
  * [139712a] Update Boost test dependencies to 1.90. (Closes: #1127058)

 -- Anton Gladky <gladk@debian.org>  Thu, 05 Feb 2026 20:07:16 +0100

boost1.90 (1.90.0-1~exp1) experimental; urgency=medium

  * New upstream version
  * Update Source, Package names, Depends/Conflicts/Suggests fields.
  * Remove obsolete patches (hurd, alpha, charconv-ppc64le fix).
  * Add support for Python 3.13/3.14 in Boost.Build configuration.
  * Clean up debian/rules and debian/copyright.

 -- Anton Gladky <gladk@debian.org>  Thu, 01 Jan 2026 19:02:08 +0100

boost1.88 (1.88.0-1.4) unstable; urgency=medium

  * Non-maintainer upload.
  * No-change upload for IEEE long double on ppc64el.

 -- Matthias Klose <doko@debian.org>  Thu, 04 Sep 2025 16:20:06 +0200

boost1.88 (1.88.0-1.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Upload to unstable.

 -- Matthias Klose <doko@debian.org>  Mon, 11 Aug 2025 12:51:50 +0200

boost1.88 (1.88.0-1.2) experimental; urgency=medium

  * Non-maintainer upload.
  * Update inter-package dependencies:
    - libboost-mpi1.88-dev: Depend on libboost-graph1.88-dev.
    - libboost-wave1.88-dev: Depend on libboost-container1.88-dev.
    - libboost-wave1.88-dev: Depend on libboost-regex1.88-dev.
  * libboost-chrono1.88.0: Provide libboost-chrono1.88.0t64.

 -- Matthias Klose <doko@debian.org>  Sun, 10 Aug 2025 14:32:59 +0200

boost1.88 (1.88.0-1.1) experimental; urgency=medium

  * Non-maintainer upload.
  * Update inter-package dependencies: Closes: #1110562, #1110589.
    - libboost-coroutine1.88-dev: Depend on libboost-exception1.88-dev.
    - libboost-locale1.88-dev: Depend on libboost-charconv1.88-dev.
    - libboost-python1.88-dev: Depend on libboost-container1.88-dev.
    - libboost-python1.88-dev: Depend on libboost-graph1.88-dev.
    - libboost-iostreams1.88-dev: Depend on libboost-random1.88-dev.
    - libboost-charconv1.88-dev: Depend on libboost-charconv1.88.0.
      Closes: #1109450.
    - libboost-mpi1.88-dev: Depend on libboost-container1.88-dev.
  * New packages libboost-process1.88.0 and libboost-process1.88-dev.
    libboost1.88-all-dev: Depends on libboost-process1.88-dev. Closes: #1106723.
  * libboost-chrono1.88.0t64: Rename to libboost-chrono1.88.0. Closes: #1110509.
  * Fix ftbfs on hurd-amd64 (Petter Reinholdtsen). Closes: #1104617, #1102194.
  * Fix ftbfs on alpha (Petter Reinholdtsen). Closes: #1104561.
  * d/rules: Replace apt show with dpkg-query (Jochen Sprickerhof).
    Closes: #1103784.
  * Fix ppc64el build with IEEE long double. LP: #2110099. Closes: #1110403.
  * https://github.com/boostorg/boost/issues/1035
  * d/rules (override_dh_auto_build-common): Don't create a stamp.
  * d/rules (clean): Remove two generated files.
  * Update watch file.

 -- Matthias Klose <doko@debian.org>  Sat, 09 Aug 2025 14:35:51 +0200

boost1.88 (1.88.0-1) unstable; urgency=medium

  * New stable version.

 -- Anton Gladky <gladk@debian.org>  Tue, 22 Apr 2025 08:38:04 +0200

boost1.88 (1.88.0~beta1-1) unstable; urgency=medium

  * [df53d4e] Disable boost.stacktrace.from_exception on some archs.
              (Closes: #1102107)
  * Upload into unstable.

 -- Anton Gladky <gladk@debian.org>  Sun, 06 Apr 2025 15:27:52 +0200

boost1.88 (1.88.0~beta1-1~exp1) experimental; urgency=medium

  * [9291fb5] Update patches for 1.88
  * [9738360] Update d/copyright
  * [1a78c7b] Update d/control, d/rules for new version

 -- Anton Gladky <gladk@debian.org>  Wed, 02 Apr 2025 20:07:45 +0200

boost1.83 (1.83.0-4.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Another fix for numpy 2.0. Closes: #1099671.
    - Compare pointers directly instead of using PyArray_EquivTypes
  * Enable context library on ppc64. Closes: #1071542.
  * Use static const for next/prior from C++17. Closes: #1093824.

 -- Matthias Klose <doko@debian.org>  Tue, 25 Mar 2025 14:04:56 +0100

boost1.83 (1.83.0-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with NumPy 2.x. Closes: #1094654.

 -- Matthias Klose <doko@debian.org>  Fri, 14 Feb 2025 16:45:31 +0100

boost1.83 (1.83.0-4) unstable; urgency=medium

  [ Samuel Thibault ]
  * control: Add hurd-amd64 for context, coroutine, fiber packages.
  * [a2dab5e] control: Add hurd-amd64 for context, coroutine, fiber packages.

  [ Heinrich Schuchardt ]
  * [62a479e] Fix autopkgtests fail on armhf. (Closes: #1079106)

  [ Anton Gladky ]
  * [49b0d7f] Update the minimal cmake version for autopkgtest to 3.18.
              (Closes: #1087853)


