=== debian/tests/control ===
Tests: atomic
Depends: libboost-atomic1.90-dev, build-essential, cmake

Tests: chrono
Depends: libboost-chrono1.90-dev, build-essential, cmake

Tests: context
Depends: libboost-context1.90-dev, build-essential, cmake

Tests: container
Depends: libboost-container1.90-dev, build-essential, cmake

Tests: coroutine
Depends: libboost-coroutine1.90-dev, build-essential, cmake

Tests: datetime
Depends: libboost-date-time1.90-dev, build-essential, cmake

Tests: exception
Depends: libboost-exception1.90-dev, build-essential, cmake
Restrictions: allow-stderr

Tests: fiber
Depends: libboost-fiber1.90-dev, build-essential, cmake

Tests: filesystem
Depends: libboost-filesystem1.90-dev, build-essential, cmake

#Tests: graph
#Depends: libboost-graph1.90-dev, build-essential, cmake
#Restrictions: allow-stderr

#Tests: graph-parallel
#Depends: libboost-graph-parallel1.90-dev, libboost-mpi1.90-dev, mpi-default-dev, build-essential, libgraph-easy-perl, cmake
#Architecture: !armhf
#Restrictions: allow-stderr

Tests: iostreams
Depends: libboost-iostreams1.90-dev, build-essential, cmake

Tests: locale
Depends: libboost-locale1.90-dev, build-essential, cmake

Tests: log
Depends: libboost-log1.90-dev, build-essential, cmake
Restrictions: allow-stderr

Tests: math
Depends: libboost-math1.90-dev, build-essential, cmake

Tests: mpi
Depends: libboost-mpi1.90-dev, mpi-default-dev, build-essential, cmake
Architecture: !armhf !i386
Restrictions: allow-stderr

#Tests: mpi-python
#Depends: libboost-mpi-python1.90-dev, mpi-default-dev, python3-minimal
#Architecture: !armhf
#Restrictions: allow-stderr

Tests: program-options
Depends: libboost-program-options1.90-dev, build-essential, cmake

Tests: python
Depends: libboost-python1.90-dev, python3-minimal, cmake, build-essential, clang
Restrictions: allow-stderr

Tests: random
Depends: libboost-random1.90-dev, build-essential, cmake

Tests: regex
Depends: libboost-regex1.90-dev, build-essential, cmake, html2text

Tests: serialization
Depends: libboost-serialization1.90-dev, libboost-random1.90-dev, build-essential, cmake

Tests: stacktrace
Depends: libboost-stacktrace1.90-dev, build-essential, cmake

#Tests: system
#Depends: build-essential, cmake
#Restrictions: allow-stderr

Tests: test
Depends: libboost-test1.90-dev, build-essential, cmake
Restrictions: allow-stderr

Tests: thread
Depends: libboost-thread1.90-dev, build-essential, cmake
Restrictions: allow-stderr

Tests: timer
Depends: libboost-timer1.90-dev, build-essential, cmake

Tests: type-erasure
Depends: libboost-type-erasure1.90-dev, build-essential, cmake

Tests: wave
Depends: libboost-wave1.90-dev, libboost-thread1.90-dev, build-essential, cmake
